Bug 1775667 - Review Request: vpl - Voxel Processing Library [NEEDINFO]
Summary: Review Request: vpl - Voxel Processing Library
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-11-22 14:34 UTC by Karel Volný
Modified: 2020-06-19 11:52 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
zebob.m: fedora-review+
zebob.m: needinfo? (kvolny)


Attachments (Terms of Use)

Description Karel Volný 2019-11-22 14:34:28 UTC
Spec URL: https://kvolny.fedorapeople.org/vpl.spec
SRPM URL: https://kvolny.fedorapeople.org/vpl-1.3.0-20191119git4e1aba67c831r1.fc31.src.rpm
Description: 
VPL (Voxel Processing Library) is an open source collection of 2D/3D image
processing tools originally aimed at medical images. It contains number
of routines for volumetric data processing like 3D filtering, edge detection,
segmentation, etc.

Fedora Account System Username: kvolny

scratchbuild: https://koji.fedoraproject.org/koji/taskinfo?taskID=39199562

Comment 1 Robert-André Mauchin 🐧 2019-12-10 19:37:40 UTC
 - License must be installed with %license not %doc:

%doc AUTHORS README.md
%license LICENSE

 - Release should start with 1:

Release: 1.20191119git4e1aba67c831r1%{?dist}

Also consider using macros to simplify updating.

 - Include URL: field

URL: https://bitbucket.org/3dimlab/vpl

 - Fix line encoding:

vpl.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/vpl/README.md

in %prep:

sed -i "s|\r||g" README.md



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-clause "New" or "Revised"
     License", "BSD 2-clause "Simplified" License". 849 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/vpl/review-vpl/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[-]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in vpl-
     devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: vpl-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-devel-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-debuginfo-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-debugsource-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-1.3.0-20191119git4e1aba67c831r1.fc32.src.rpm
vpl.x86_64: W: spelling-error Summary(en_US) Voxel -> Vowel
vpl.x86_64: W: spelling-error %description -l en_US volumetric -> cliometric
vpl.x86_64: W: no-url-tag
vpl.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/vpl/README.md
vpl-devel.x86_64: W: no-url-tag
vpl-devel.x86_64: W: no-documentation
vpl-debuginfo.x86_64: W: no-url-tag
vpl-debugsource.x86_64: W: no-url-tag
vpl.src: W: spelling-error Summary(en_US) Voxel -> Vowel
vpl.src: W: spelling-error %description -l en_US volumetric -> cliometric
vpl.src: W: no-url-tag
5 packages and 0 specfiles checked; 0 errors, 11 warnings.

Comment 2 Robert-André Mauchin 🐧 2019-12-10 19:38:25 UTC
 - License must be installed with %license not %doc:

%doc AUTHORS README.md
%license LICENSE

 - Release should start with 1:

Release: 1.20191119git4e1aba67c831r1%{?dist}

Also consider using macros to simplify updating.

 - Include URL: field

URL: https://bitbucket.org/3dimlab/vpl

 - Fix line encoding:

vpl.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/vpl/README.md

in %prep:

sed -i "s|\r||g" README.md



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-clause "New" or "Revised"
     License", "BSD 2-clause "Simplified" License". 849 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/vpl/review-vpl/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[-]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in vpl-
     devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: vpl-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-devel-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-debuginfo-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-debugsource-1.3.0-20191119git4e1aba67c831r1.fc32.x86_64.rpm
          vpl-1.3.0-20191119git4e1aba67c831r1.fc32.src.rpm
vpl.x86_64: W: spelling-error Summary(en_US) Voxel -> Vowel
vpl.x86_64: W: spelling-error %description -l en_US volumetric -> cliometric
vpl.x86_64: W: no-url-tag
vpl.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/vpl/README.md
vpl-devel.x86_64: W: no-url-tag
vpl-devel.x86_64: W: no-documentation
vpl-debuginfo.x86_64: W: no-url-tag
vpl-debugsource.x86_64: W: no-url-tag
vpl.src: W: spelling-error Summary(en_US) Voxel -> Vowel
vpl.src: W: spelling-error %description -l en_US volumetric -> cliometric
vpl.src: W: no-url-tag
5 packages and 0 specfiles checked; 0 errors, 11 warnings.

Comment 3 Karel Volný 2019-12-16 14:49:22 UTC
(In reply to Robert-André Mauchin from comment #2)
>  - License must be installed with %license not %doc:
> 
> %doc AUTHORS README.md
> %license LICENSE

I see, stupid me :-(

>  - Release should start with 1:
> 
> Release: 1.20191119git4e1aba67c831r1%{?dist}

I've followed https://docs.fedoraproject.org/en-US/packaging-guidelines/Versioning/#_snapshots

the suggested format says "YYYYMMDD<scm><revision>", not "1.YYYYMMDD<scm><revision>"

so where does it come from?
- should the docs be updated?

> Also consider using macros to simplify updating.

not sure what do you mean?

I've followed https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_git_hosting_services and wasn't able to come up with something better?

>  - Include URL: field
> 
> URL: https://bitbucket.org/3dimlab/vpl

hm, I totally forgot about it - I would have included it if the template and the packaging guidelines overview wouldn't omit it ... strange, why?
- never mind, I'm adding it as it is not in MUST/SHOULD NOT tags list

>  - Fix line encoding:
> 
> vpl.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/vpl/README.md
> 
> in %prep:
> 
> sed -i "s|\r||g" README.md

generally, I tend to ignore line end conversions, but whatever ... :-)


thanks for the review

I'll upload updated version once will sort out the above questions

Comment 4 Robert-André Mauchin 🐧 2019-12-16 18:36:40 UTC
Quote:

The methods for dealing with most of these issues involves potentially removing some information from the Version: tag while imposing additional structure onto the Release: tag. There are potentially four fields which comprise the structured Release: tag:

    package release number (<pkgrel>)

    extra version information (<extraver>)

    snapshot information (<snapinfo>)

    minor release bump (<minorbump>)

The package release number MUST always be present while the others may or may not be depending on the situation.

Those items which are present are combined (with periods to separate them) to construct the final Release: tag. In the usual notation where square brackets indicate that an item is optional:

<pkgrel>[.<extraver>][.<snapinfo>]%{?dist}[.<minorbump>]



YYYYMMDD<scm><revision> is the snapinfo part of the equation, you still need the <pkgrel>, which start at 1 for released version or 0.1 for prerelease:

Prerelease versions

In the Version: tag, use the version that upstream has determined the next release will be. For the field of the Release: tag, use a number of the form "0.N" where N is an integer beginning with 1 and increasing for each revision of the package. Prerelease versions MUST use a Release: tag strictly less than 1, as this is the sole indicator that a prerelease has been packaged.


>> Also consider using macros to simplify updating.

>not sure what do you mean?

 I mean using the %{shortcommit} macro in Release so you don't have to charge it every release:

Release: 1.20191119git%{shortcommit}%{?dist}

Comment 5 Karel Volný 2019-12-17 11:17:18 UTC
oh my ... I must be overworked, I've missed so many things :-/

thanks

I've updated the spec in place, without versioning as this is WIP:
https://kvolny.fedorapeople.org/vpl.spec

the srpm name changed due to the Release change:
https://kvolny.fedorapeople.org/vpl-1.3.0-1.20191119git4e1aba67c831.fc31.src.rpm

changes:

--- vpl.spec~   2019-11-22 12:35:00.000000000 +0100
+++ vpl.spec    2019-12-17 12:14:12.108375590 +0100
@@ -1,13 +1,15 @@
+%global commit 4e1aba67c8313b83b0e10eb1397242422e63c1d3
+%global gittag HEAD
+%global shortcommit %(c=%{commit}; echo ${c:0:12})
+
 Name:    vpl
 Version: 1.3.0
-Release: 20191119git4e1aba67c831r1%{?dist}
+Release: 1.20191119git%{shortcommit}%{?dist}
 Summary: Voxel Processing Library
+URL:     https://bitbucket.org/3dimlab/vpl
 
 License: BSD
 
-%global commit 4e1aba67c8313b83b0e10eb1397242422e63c1d3
-%global gittag HEAD
-%global shortcommit %(c=%{commit}; echo ${c:0:12})
 # wget https://bitbucket.org/3dimlab/vpl/get/4e1aba67c8313b83b0e10eb1397242422e63c1d3.tar.gz
 # mv 4e1aba67c8313b83b0e10eb1397242422e63c1d3.tar.gz vpl-4e1aba67c831.tar.gz
 Source0: https://bitbucket.org/3dimlab/%{name}/get/%{commit}.tar.gz#/%{name}-%{shortcommit}.tar.gz
@@ -47,6 +49,7 @@
 %prep
 %autosetup -n 3dimlab-%{name}-%{shortcommit} -p1
 rm CMakeModules/FindTinyXML.cmake
+sed -i -e "s|\r||g" README.md
 
 %build
 if [[ %{_lib} == "lib64" ]]; then
@@ -61,12 +64,13 @@
 
 %files
 %{_libdir}/*so
-%doc AUTHORS LICENSE README.md
+%doc AUTHORS README.md
+%license LICENSE
 
 %files devel
 %{_includedir}/VPL
 %{_libdir}/pkgconfig/*
 
 %changelog
-* Thu Nov 21 2019 Karel Volny <kvolny@redhat.com> 1.3.0-20191119git4e1aba67c831r1
+* Tue Dec 17 2019 Karel Volny <kvolny@redhat.com> 1.3.0-1.20191119git4e1aba67c831
 - New package

Comment 6 Robert-André Mauchin 🐧 2020-06-19 11:52:21 UTC
Package approved.


Note You need to log in before you can comment on or make changes to this bug.